#include "matrix.h"

void compute() {

  matrix mat1;
  matrix mat2;
  matrix mat3;
  matrix mat4;

  int arr[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};

  printf("init\n");
  matrix_init(&mat1, 8, 6, 1);
  matrix_print(mat1);

  printf("init from array\n");
  matrix_init_from_array(&mat2, 3, 3, arr);
  matrix_print(mat2);

  printf("clone\n");
  matrix_clone(&mat3, mat1);
  matrix_print(mat3);

  printf("compare cloned matrix :");
  if (matrix_is_equal(mat1, mat3)) {
    printf(" equal\n\n");
  } else {
    printf("not equal\n\n");
  }

  printf("transpose\n");
  matrix_transpose(&mat4, mat3);
  matrix_print(mat4);

  matrix_destroy(&mat1);
  printf("submatrix\n");
  matrix_extract_submatrix(&mat1, mat4, 4, mat4.m, 4, mat4.n);
  matrix_print(mat1);

  printf("set element [1][2] to 0\n");
  matrix_set(mat1, 1, 2, 0);
  matrix_print(mat1);

  printf("double each item\n");
  matrix_map_ip(mat1, mult2);
  matrix_print(mat1);

// matrix mat5;
// matrix mat6;

//   int arr1[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};
//   matrix_init_from_array(&mat6, 3, 3, arr1);
//   matrix_print(mat6);

//   matrix_extract_submatrix(&mat5, mat6, mat6.n, 1, mat6.m, 2);
//   matrix_print(mat5);
  // matrix_map_ip2(mat1,6, multX);

  matrix_destroy(&mat1);
  matrix_destroy(&mat2);
  matrix_destroy(&mat3);
  matrix_destroy(&mat4);
  // matrix_destroy(&mat5);
  // matrix_destroy(&mat6);
}