#ifndef _SORT_H_
#define _SORT_H_

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>

bool isSorted(int size, int tab[size], bool (*comp)(int, int));

void random_tab(int size,int tab[size],int min,int max);

bool isGreater(int a, int b);

bool isSmaller(int a, int b);

void swap(int *a, int *b);

void print_array(int *arr, int size);


void sort(int *sorted, const int *const orig, int nitems,bool (*comp)(int, int));




#endif