#include "queue_array.h"


// typedef struct _queue {
//    T* data;
//    int lastIN; //dernier ajouté (head)
//    //int firstIN; //index 0 est le premier ajouté
//    int capacity;
// } queue;

queue createQ() {
  queue Q;
  Q.capacity = 1;
  Q.lastIN = -1;
  Q.data = malloc(sizeof(int));
  return Q;
}

void destroyQ(queue *Q) {
  free(Q->data);
  Q->capacity = -1;
}

void resizeQ(queue *Q, int max) {
    Q->capacity = max;
    Q->data = realloc(Q->data, max * sizeof(int));
}

void insertQ(queue *Q, T value) {
  if (Q->capacity - 1 == Q->lastIN) { // IF FULL
    resizeQ(Q, Q->capacity + 1);
  }
  Q->lastIN++;
  Q->data[Q->lastIN] = value;
}

T extractFirst(queue *Q) { // a l'index 0
    T tmp=Q->data[0];

    for(int i=0;i<Q->lastIN;i++){
        Q->data[i]=Q->data[i+1];
    }

    Q->lastIN--;

    resizeQ(Q, Q->capacity-1);
    return tmp;
 }

T getFirst(queue Q){
    return Q.data[Q.lastIN];
}

bool isQueueEmpty(queue Q){
    return Q.capacity==-1;
}
int queueCount(queue Q){
    return Q.capacity;
}

void displayQ(queue Q){
  for(int i=0;i<Q.capacity;i++){
    printf("%d ",Q.data[i]);
  }
  printf("\n");
}


int main() {

  queue Q = createQ();

  for (int i = 0; i < 10; i++) {
    insertQ(&Q, i);
  }
    displayQ(Q);
    extractFirst(&Q);
    displayQ(Q);


    
  return EXIT_SUCCESS;
}