#ifndef _QUEUE_ARRAY_H_
#define _QUEUE_ARRAY_H_

#include <assert.h>
#include <math.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>


typedef int T;

typedef struct _queue {
   T* data;
   int lastIN; //dernier ajouté (head)
   //int firstIN; //index 0 est le premier ajouté
   int capacity;
} queue;

queue createQ(); 
void destroyQ(queue *Q);
void insertQ(queue *Q, T value); //a la fin
T extractFirst(queue *Q); //a l'index 0
T getFirst(queue Q);
bool isQueueEmpty(queue Q);
int queueCount(queue Q);
void displayQ(queue Q);

#endif