#ifndef _STACK_H_
#define _STACK_H_

#include <assert.h>
#include <math.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct _stack {

  void **data;
  int top;
  int capacity;

} stack;



bool is_empty(stack stack);

bool is_full(stack stack);

void* peek(stack stack);

int stack_count(stack stack);

void stack_init(stack *stack, int size);

void stack_destroy(stack *stack);

void push(stack *stack, void* item);

void* pop(stack *stack);

#endif

