#include "pointer_sort.h"
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

void swap(int *a, int *b) {
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

void print_array_ptr(int **arr, int size) {
  for (int i = 0; i < size; i++) {
    printf("%d ", *arr[i]);
  }
  printf("\n");
}

int* random_tab(int size,int min,int max) {
   assert(max > min);
   int* tab=malloc(sizeof(int)*size);

   for (int i=0;i<size;i++) {
      tab[i] = min+rand()%(max-min);
   }
   return tab;
}


int **sort(int *orig, int size) {

  int **ptr = malloc(sizeof(int *) * size);
  // copy addresses
  for (int i = 0; i < size; i++) {
    ptr[i] = &orig[i];
  }

  // print_array_ptr(ptr, size);
  for (int j = size; j > 1; j--) {

    for (int i = 0; i < j-1; i++) {
      // ptr[0] est un pointeur *ptr[0] est la valeur pointée
      if (*ptr[i] > *ptr[i + 1]) {
        swap(ptr[i], ptr[i + 1]);
      }
    }
    printf("[%d] ",j);
     print_array_ptr(ptr, size);
  }
  return ptr;
}