#ifndef _QUEUE_LIST_H_
#define _QUEUE_LIST_H_

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>
#include <time.h>

typedef struct _pixel{
    int x;
    int y;
} pixel;

typedef pixel T;

typedef struct _element {
    T pixel;
    struct _element *next;
} element;

typedef struct _queue {
   element* firstIn; //head
   element* lastIn; //debut
} queue;

queue createQ(); 
void destroyQ(queue *Q);
void insertQ(queue *Q, T value); //a la fin
T extractFirst(queue *Q); //a l'index 0
T getFirst(queue Q);
bool isQueueEmpty(queue Q);
int queueCount(queue Q);
void displayQ(queue Q);
pixel pixel_init(int x,int y);
//void start(int height,int width,snake snk);


#endif 