#ifndef _SNAKE_H_
#define _SNAKE_H_
#include "queue.h"
#include "gfx.h"

typedef enum _dir{LEFT,RIGHT,UP,DOWN} dir;

typedef enum _map{wall=MAKE_COLOR(255, 255, 255),empty=MAKE_COLOR(0,0,0),food=MAKE_COLOR(0, 255, 0),body=MAKE_COLOR(255, 0, 0)} map;

typedef struct _snake{
    queue body;
    dir dir;
    int currentFood;
} snake;

void snake_init(snake *snk, int height, int width);
void step(snake *snk, struct gfx_context_t *ctxt);
void input_handler(snake *snk,SDL_Keycode key);
void generateFood(struct gfx_context_t *ctxt,int width, int height);

#endif 