#include "matrix.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

int main(){

  matrix mat1;
  matrix mat2;
  matrix mat3;
  matrix mat4;
  
  int arr[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};

  //printf("init\n");
  assert(matrix_init(&mat1, 8, 6, 1)==ok);
  assert(matrix_print(mat1)==ok);

  //printf("init from array\n");
  assert(matrix_init_from_array(&mat2, 3, 3, arr)==ok);
  assert(matrix_print(mat2)==ok);

  //printf("clone\n");
  assert(matrix_clone(&mat3, mat1)==ok);
  assert(matrix_print(mat3)==ok);

  //printf("compare cloned matrix :");
  assert(matrix_is_equal(mat1, mat3));

  //printf("transpose\n");
  assert(matrix_transpose(&mat4, mat3)==ok);
  assert(matrix_print(mat4)==ok);

  assert(matrix_destroy(&mat1)==ok);
  //printf("submatrix\n");
  assert(matrix_extract_submatrix(&mat1, mat4, 2, mat4.m, 2, mat4.n)==ok);
  assert(matrix_print(mat1)==ok);

  //printf("set element [1][2] to 0\n");
  assert(matrix_set(mat1, 1, 2, 0)==ok);
  assert(matrix_print(mat1)==ok);

  //printf("double each item\n");
  assert(matrix_map_ip(mat1, mult2)==ok);
  assert(matrix_print(mat1)==ok);

  //assert(matrix_map_ip2(mat1,6, multX);

  assert(matrix_destroy(&mat1)==ok);
  assert(matrix_destroy(&mat2)==ok);
  assert(matrix_destroy(&mat3)==ok);
  assert(matrix_destroy(&mat4)==ok);

return EXIT_SUCCESS;
}