#include "sort.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>


int main() {

  srand(time(NULL));

  int size = 1000;
  int orig[size];
  int sorted[size];

  struct timespec start, finish;
  clock_gettime(CLOCK_MONOTONIC, &start);
  
  // code à mesurer
  for (int i = 0; i < 1000; i++) {
    random_tab(size, orig, 1, 500);

    sort(sorted, orig, size, isGreater);
   // assert(isSorted(size, sorted, isSmaller));
    

    // sort(sorted, orig, size, isSmaller);
    // assert(isSorted(size, sorted, isGreater));
  }

  clock_gettime(CLOCK_MONOTONIC, &finish);
  double seconds_elapsed = finish.tv_sec - start.tv_sec;
  seconds_elapsed += (finish.tv_nsec - start.tv_nsec) / 1.0e9;
  printf("time elapsed : %f sec\n", seconds_elapsed);

  // print_array(orig,size);
  // print_array(sorted,size);

  return EXIT_SUCCESS;
}
