#ifndef _QUEUE_LIST_H_
#define _QUEUE_LIST_H_

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>

typedef int T;

typedef struct _element {
    T data;
    struct _element *next;
} element;

typedef struct _queue {
   element* firstIn; //head
   element* lastIn; //debut
} queue;

queue createQ(); 
void destroyQ(queue *Q);
void insertQ(queue *Q, T value); //a la fin
T extractFirst(queue *Q); //a l'index 0
T getFirst(queue Q);
bool isQueueEmpty(queue Q);
int queueCount(queue Q);
void displayQ(queue Q);


#endif

