


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _element {
  char c;
  struct _element *next;
} element;

void push(element **chain, char data) {

  element *tmp = malloc(sizeof(element));
  tmp->c = data;
  tmp->next = *chain;
  *chain = tmp;
}

void fill_chain(element **chain, char *str, int len) {
  for (int i = len; i >= 0; i--) {
    push(chain, str[i]);
  }
}

void chain_split(element **chain1, element **chain2, int len) {
  int len1 = len / 2;
  int len2 = len - len1;
  element *current = *chain1;
  for (int i = 0; i < len1-1; i++) {
    current = current->next;
  }
  chain2=&current;
  current=NULL;
  printf("\n\n\n\n %c \n\n\n\n ",current->c);
}

void chain_delete(element **ch) {

  element *delete;

  while ((*ch)->next != NULL) {
    delete = *ch;
    *ch = (*ch)->next;
    free(delete);
  }
  // free(*ch);
}

void print_chain(element *ch) {

  while (ch != NULL) {
    printf("%c\n", ch->c);
    ch = ch->next;
  }
  printf("\n");
}

int main() {

  char str[16];
  scanf("%s", str);
  int len = strlen(str);

  element *chain1;
  element *chain2;
  fill_chain(&chain1, str, len);
  chain_split(&chain1, &chain2, len);
  // print_chain(chain);
  // chain_delete(&chain);

  //   for (int i = 0; i < 2; i++) {
  //     char str[16];
  //     scanf("%s", str);
  //     int len = strlen(str);

  //     element* chain;
  //     fill_chain(&chain, str, len);
  //     print_chain(chain);
  //   }
  return EXIT_SUCCESS;
}