#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void swap(float *a, float *b) {
  float tmp = *a;
  *a = *b;
  *b = tmp;
}

void sort(float *arr, int nitems) {

  for (int j = nitems - 1; j > 1; j--) {

    for (int i = 0; i < j; i++) {
      if (arr[i] > arr[i + 1]) {
        swap(&arr[i], &arr[i + 1]);
      }
    }
  }
}

int main() {
  float money;
  float bill = 0;
  int size = 10;
  float list[size];
  char dummy[80];

  scanf("%f", &money);

  for (int i = 0; i < size; i++) {
    scanf("%s %f", dummy, &list[i]);
  }

  sort(list, size);

  for (int i = 0; i < size; i++) {
    if (list[i] < money) {
      bill += list[i];
      money -= list[i];
    }
  }
  printf("\n%.1f\n", bill);

  return EXIT_SUCCESS;
}