#ifndef _HASH_H_
#define _HASH_H_

#include <malloc.h>
#include <stdbool.h>
#include <stdio.h>
#include "lst_vec.h"
#include <malloc.h>
#include <string.h>

typedef struct _entry_t entry_t;

typedef struct _hm_t hm_t;

// création d'un pointeur vers une hm
hm_t *hm_create(int length);
// destruction de la hm et libération de la mémoire
void hm_destroy(hm_t **hm);

// insère la paire key-value dans la hm. si key est déjà présente
// écraser value dans la hm.
hm_t *hm_set(hm_t *hm, char *key, char *value);
// retourne la valeur associé à la clé, key
char *hm_get(hm_t *hm, char *key);

// retire une clé de la hm et la retourne
char* hm_rm(hm_t *hm, char *key);
// affiche le contenu de la hm
void hm_print(hm_t *hm);

void destroyEntry(entry_t *entry);
#endif