#include "quadTree.h"

int main(int argc, char **argv) {

  if (argc == 1) {
    printf("need more arguments (minimum filename) !\nusage: ./main.x out.pgm -c [0,1] -s [1,3]\n");
    return EXIT_FAILURE;
  }

  node *tree = tree_from_file("pgm/buzz_octets.pgm");

  for (int i = 0; i < argc; i++) {
    if (!strcmp(argv[i], "-c")) {
      compress_with_rate(tree, atof(argv[++i]));
    } else if (!strcmp(argv[i], "-s")) {
      symetry(tree, atoi(argv[++i]));
    }
  }

  tree_to_file(tree, argv[1]);
  tree_destroy(tree);

  return EXIT_SUCCESS;
}
