#include <stdlib.h>
#include <stdint.h>
#include "snake.h"
#include <unistd.h>



int main(){
//
    int width = 240, height = 135;
    int maxFood=10;

    snake snk;
    snake_init(&snk, height,width);

    struct gfx_context_t *ctxt = gfx_create("Serpent", width, height);

    if (!ctxt) {
        fprintf(stderr, "Graphics initialization failed!\n");
        return EXIT_FAILURE;
    }

    
    //draw walls
    for(int y=0;y<height;y++){
        for(int x=0;x<width;x++){
            if(y==0||x==0||x==width-1||y==height-1){
                gfx_putpixel(ctxt, x,y, wall);
            }
        }
    }
    SDL_Keycode key;
    while (key != SDLK_ESCAPE) {
        key=gfx_keypressed();
        //gfx_clear(ctxt, COLOR_BLACK);
        input_handler(&snk,key);
        step(&snk, ctxt);

        if(snk.currentFood<maxFood){
            snk.currentFood++;
            generateFood(ctxt, width, height);
            //printf("%d\n",snk.currentFood);
        }


        element* tmp=snk.body.firstIn;

        while(tmp!=NULL){
            gfx_putpixel(ctxt, tmp->pixel.x,tmp->pixel.y, body);
            tmp=tmp->next;
        }
        usleep(30000);
        //uint color = MAKE_COLOR(val, val, val);
        //gfx_putpixel(ctxt, x, y, color);
      
    

    gfx_present(ctxt);
  }

    gfx_destroy(ctxt);

    return EXIT_SUCCESS;
}