#include "munit/munit.h"
#include "tree.h"

MunitResult test_init() //f de test
{   
    node_t *tree=bst_create();
    munit_assert_ptr_not_equal(tree,NULL);
    return MUNIT_OK;
}

MunitResult test_insert() //f de test
{
    node_t (*tree)=bst_create();
    bst_insert(tree,10);
    bst_insert(tree,5);
    bst_insert(tree,15);
    bst_insert(tree,2);
    bst_insert(tree,6);
    bst_print(tree,0);

    return MUNIT_OK;
    
}

MunitTest tests[] = {// liste de tests
    {
        "/init",/* name */
        test_init,/* test */
        NULL,/* setup */
        NULL,/* tear_down */
        MUNIT_TEST_OPTION_NONE,/* options */
        NULL/* parameters */
    },{
        "/insert",/* name */
        test_insert,/* test */
        NULL,/* setup */
        NULL,/* tear_down */
        MUNIT_TEST_OPTION_NONE,/* options */
        NULL/* parameters */
    },
    /* La fin de la liste de tests */
    { NULL, NULL, NULL, NULL, MUNIT_TEST_OPTION_NONE, NULL },
};

const MunitSuite test_suite={
    (char*)"les supers tests youpi",
    tests,
    NULL,
    1,
    MUNIT_SUITE_OPTION_NONE,
};

int main(int argc, char** argv){
    return munit_suite_main(&test_suite, NULL, argc,argv);
}